
function process_event(e)
{
  if (e==null) return;

  local t=typeof e

  if (e!="update") print("Script event: "+t+" <"+e+">\n")

  if (t=="function") e()
  else if (t=="string")
  {
    if (e=="toggle_monsters")
    {
      monster_spawn_enabled=!monster_spawn_enabled
      if (!monster_spawn_enabled) remove_all_monsters()
    }
    else if (e=="toggle_universe_devmode")
      universe_devmode=!universe_devmode
  }

  foreach (l in listeners) l._processEvent(e)
  // print("processed script event: "+t+" <"+e+">\n")
}


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


controllers <- []
destroyed_controllers <- []


function reset_controllers()
{
  controllers.clear()
  destroyed_controllers.clear()
}


function destroy_controllers()
{
  foreach (c in destroyed_controllers)
    foreach (i,v in controllers)
      if (v==c) { controllers.remove(i); break; }

  destroyed_controllers.clear()
}


class Controller
{
  </persistent=1/> isDestroyed=false

  constructor(params=null)
  {
    if (params) foreach (n,v in params)
      if (n in this) this[n]=v

    controllers.append(this)
  }

  function destroy()
  {
    if (isDestroyed) return;
    isDestroyed=true
    destroyed_controllers.append(this)
  }

  function update(dt) {}
}


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


update_check_delay<-0.0
update_event_period<-0.5


function update_script(dt)
{
  update_check_delay-=dt
  if (update_check_delay<=0)
  {
    update_check_delay=update_event_period
    destroy_listeners()
    process_event("update")
    destroy_listeners()
    // check_conditions()
  }

  destroy_controllers()
  foreach (c in controllers) if (!c.isDestroyed) c.update(dt)
  destroy_controllers()
}
