
foreach (name in split(@"
  utils
  universe
  save
  topology
  geometry
  listeners
  events
  worldElements
  filler
  generator
  crafting
  tutorial
  darkWorlds
  test
  ", " \t\r\n")) include("gen/"+name+".nut")


in_main_menu <- false
cur_world <- null
universe <- null


function generate_world(reason)
{
  in_main_menu=(reason=="main_menu")

  reset_listeners()
  reset_controllers()

  // test_crafting() //==

  cur_world=null
  if (universe && universe.enteredWorld>=0
    && universe.enteredWorld<universe.worlds.len())
      cur_world=universe.worlds[universe.enteredWorld]

  if (!cur_world)
  {
    cur_world=make_world(0, 0, tocolor(hsv2rgba(frnd()*360, rndf(0.5, 1), rndf(0.4, 0.7), 1)))
    cur_world.id <- -1
    cur_world.mainRewards.star<-5
    cur_world.bonusRewards.shard<-2
    cur_world.bonusRewards.firebloom<-1
    // cur_world.scheme="starting_world normal" //==
    // cur_world.scheme="tree_puzzle_world normal" //==
    // cur_world.scheme="crafting_world normal" //==
    cur_world.scheme="generic normal" //==
    // cur_world.scheme="generic dark" //==
    if (in_main_menu) cur_world.scheme="main_menu normal"
    add_all_spells()
    // cur_world.seed=1423146037 //==
  }

  cur_world.visited=true

  print(format("world seed: %d\n", cur_world.seed))
  set_rnd_seed(cur_world.seed)
  reseed_noise()

  if (reason!="test_pal")
    cur_world_pal=get_world_pal(format("pal%02d", irnd()%30+1)) //== use pal from uni data

  if (reason!="test_pal")
  {
    local ha=frnd()*PI*2, va=rndf(-5, 30)*PI/180
    set_sun_dir(make4f(cos(ha)*cos(va), sin(va), sin(ha)*cos(va), 0))
    set_sky_name("normal")
  }

  local gen=_WELEM("!WorldGen", cur_world.scheme)()
  // local gen=TestGen()
  print(format("world tags: %s\n", cur_world.scheme))
  print(format("selected %s\n", get_global_name(gen.getclass())))
  gen.worldTags.append(cur_world.scheme)
  gen.generate()

  // WorldPortal(vec4f(0, 0, 20, 1)) //==
  // SpellObject(-20, 20, "FireballSpell") //==
  // GlobResObject(20, 20, "firebloom", 1) //==
  // BirdMonster(vec4f(0, get_land_height(0, 50)+30, 0, 1), make_dir_xz(frnd())).setBodyModel("bird", 0xff00ff00) //==
  // Tentacle(vec4f(0, 40, 40, 1)) //==
  // for (local z=0; z<=40; z+=5) Tentacle(vec4f(0, 10, 40+z, 1), vec4f(1, 10, 0, 0), 16, 4) //==

  wgen=null
  update_check_delay=0.0
}
