

class BossMockupLeg
{
  tentacle=null
  body=null
  bodyOfs=0
  ofs=0
  dir=0
  retargetDelay=0
  upOfs=0

  constructor(b, bo, xo)
  {
    body=b
    bodyOfs=bo
    ofs=xo
    dir=(ofs>0?1:-1)

    tentacle=Tentacle(body.getSplinePos(bodyOfs)+vec4f(ofs, 0, 0, 0),
      vec4f(dir, 8, 0, 0), 20, 2)
    tentacle.setTipSpeed(20)
    tentacle.setBodyModel("ctrplr-b01")
    tentacle.setTailModel("ctrplr-t")
    tentacle.setScale(3, 1.5)
    tentacle.setBending(0.0, 0.2)
    tentacle.setTargetPos(tentacle.getSplinePos(0)+vec4f(dir*15, -5, 0, 0), vec4f(0, -1, 0, 0))
    tentacle.setColors(0xff001177, 0xffff1100)

    retargetDelay=(bo%2>1?0.1*PI:0)
  }

  function update(dt)
  {
    local p=body.getSplinePos(bodyOfs)

    upOfs-=dt*15*3
    if (upOfs<0) upOfs=0

    retargetDelay-=dt
    if (retargetDelay<=0)
    {
      // retargetDelay=rndf(2, 4)
      retargetDelay=0.2*PI
      tentacle.setTargetPos(p+vec4f(dir*rndf(10, 30), 0, srnd()*5, 0), vec4f(0, -1, 0, 0))
      upOfs=rndf(10, 20)
    }

    tentacle.setBasePos(p+vec4f(ofs, -2, 0, 0), vec4f(dir, 1, 0, 0))
    tentacle.setTargetPos(get_land_pos_at(tentacle.getTargetPos())+vec4f(0, upOfs, 0, 0),
      vec4f(0, -1, 0, 0))
  }
}


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


class BossMockupShooter
{
  tentacle=null
  body=null
  bodyOfs=0
  ofs=0
  dir=0

  constructor(b, bo, xo)
  {
    body=b
    bodyOfs=bo
    ofs=xo
    dir=(ofs>0?1:-1)

    tentacle=Tentacle(body.getSplinePos(bodyOfs)+vec4f(ofs, 0, 0, 0),
      vec4f(dir, 0, 0, 0), 20, 2)
    tentacle.setTipSpeed(15)
    tentacle.setBodyModel("ctrplr-b02")
    tentacle.setTailModel("ctrplr-t")
    tentacle.setScale(0.5, 1)
    tentacle.setBending(0.0, 0.15)
    tentacle.setGravity(0.02)
    tentacle.setTargetPos(tentacle.getSplinePos(0)+vec4f(dir*15, -5, 0, 0), vec4f(0, -1, 0, 0))
    tentacle.setColors(0xff001177, 0xffff1100)
  }

  function update(dt)
  {
    local wt=get_world_time()

    local p=body.getSplinePos(bodyOfs)
    tentacle.setBasePos(p+vec4f(ofs, 1, 0, 0), vec4f(dir, 0, -1, 0))

    local p0=
      p+vec4f(
        dir*20+15*fractal_noise1(wt*0.5+bodyOfs*33+17, 3, null, 0.5),
        10+20*fractal_noise1(wt*0.5+bodyOfs*33, 3, null, 0.5),
        0, 0)
    p0+=vec4f(sin(wt*15)*20, fabs(sin(wt*5))*20-10, fabs(sin(wt*5))*20-10, 0)
    local d0=vec4f(dir, 0, 0, 0)

    local a=PI-(bodyOfs-7.3)*PI/7
    local p1=
      body.getSplinePos(7)+vec4f(dir*sin(a)*3, 17+cos(a)*3, a*1.5/PI, 0)
    local d1=vec4f(-dir*sin(a)*2, -cos(a), -2, 0)

    local k=smoothstep(10, 20, wt)
    k=0
    tentacle.setTargetPos(lerp(p0, p1, k), lerp(d0, d1, k))
  }
}


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


class BossMockupHeadTentacle
{
  tentacle=null
  body=null
  ox=0
  oy=0
  oz=0
  dir=null
  delay=0

  constructor(b, x, y, z, d)
  {
    body=b
    ox=x
    oy=y
    oz=z
    dir=norm3(d)

    tentacle=Tentacle(body.getSplinePos(0)+vec4f(ox, oy, oz, 0), dir, 10, 1)
    tentacle.setTipSpeed(5*3)
    tentacle.setBodyModel("ctrplr-b02")
    tentacle.setTailModel("ctrplr-t")
    tentacle.setScale(1, 0.1)
    tentacle.setBending(0.0, 0.15)
    tentacle.setGravity(0.02)
    tentacle.setColors(0xffff1100, 0xff550077)
  }

  function update(dt)
  {
    local wt=get_world_time()

    local p=body.getSplinePos(0)+vec4f(ox, oy, oz, 0)
    tentacle.setBasePos(p, dir)

    delay-=dt
    if (delay<=0)
    {
      delay=rndf(0.5, 2)*0.5
      tentacle.setTargetPos(p+dir*2+vec4f(srnd(), srnd(), srnd()*0, 0)*2+vec4f(0, -2, -1, 0)*2
        +vec4f(-sin(wt*2.5)*10, 0, 0, 0), dir)
    }
  }
}


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


class BossMockupController extends Controller
{
  body=null
  legs=null
  shooters=null


  constructor()
  {
    base.constructor()

    body=Tentacle(vec4f(50, 35-25, 30, 1), vec4f(0, 0, 5, 0), 15, 4)
    body.setTipSpeed(15*2)
    body.setBodyModel("ctrplr-b04")
    body.setHeadModel("boss-h")
    body.setTailModel("ctrplr-t")
    body.setScale(8, 4)
    body.setGravity(0.01)
    body.setBending(0.02, 0.05)
    body.setTargetPos(body.getSplinePos(0)+vec4f(0, 5, 25, 0), vec4f(0, 1, 1, 0))
    body.setColors(0xffff1100, 0xff0011cc)

    legs=[]
    for (local t=2.5; t<9; t+=1)
    {
      local xo=2-(t-2)*1/6
      legs.append(BossMockupLeg(body, t,  xo))
      legs.append(BossMockupLeg(body, t, -xo))
    }

    shooters=[]
    for (local t=7.9; t<14; t+=1)
    {
      local xo=1
      shooters.append(BossMockupShooter(body, t,  xo))
      shooters.append(BossMockupShooter(body, t, -xo))
    }

    shooters.append(BossMockupHeadTentacle(body, 0, -9, -10, vec4f(0, -1, -1, 0)))
    shooters.append(BossMockupHeadTentacle(body,  3.5, -7, -8, vec4f( 1, -1, -1, 0)))
    shooters.append(BossMockupHeadTentacle(body, -3.5, -7, -8, vec4f(-1, -1, -1, 0)))
    shooters.append(BossMockupHeadTentacle(body,  2.5, -8.5, -9.5, vec4f( 1, -2, -2, 0)))
    shooters.append(BossMockupHeadTentacle(body, -2.5, -8.5, -9.5, vec4f(-1, -2, -2, 0)))
  }

  function update(dt)
  {
    local avgh=0.0

    foreach (l in legs)
    {
      l.update(dt)
      avgh+=get_land_height_at(l.tentacle.getTipPos())
    }

    avgh/=legs.len()

    foreach (s in shooters) s.update(dt)

    local wt=get_world_time()

    local p=body.getSplinePos(0)
    local dy=(avgh+19-5+2*fractal_noise1(wt*0.3, 3, null, 0.5)+5*fabs(sin(wt*5))-gety(p))*0.2*3
    local maxdy=0.25*10
    if (dy>maxdy) dy=maxdy
    else if (dy < -maxdy) dy=-maxdy
    p+=vec4f(50+2*fractal_noise1(wt*0.3+44, 3, null, 0.5)
      +sin(wt*5/2)*10
      -getx(p), dy, 0, 0)

    body.setBasePos(p, vec4f(0, 1, 1, 0))
    body.setTargetPos(p+vec4f(0, 20+fabs(sin(wt*5))*10, 47, 0), vec4f(0, 4, 1, 0))
  }
}


//ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ//


class TestGen extends WorldGenerator
{
  // tags="WorldGen"

  function afterTopo()
  {
    base.afterTopo()
    foreach (e in getGroup("fillWE")) e.afterTopo()
  }

  function generate()
  {
    local function testRequest(r)
    {
      print(format("WELEMS(\"%s\"):\n", r))
      local elems=_WELEMS(r)
      foreach (e in elems)
      {
        foreach (n,v in getroottable())
          if (v==e) { print("  "+n); break; }
      }
      print("\n")
    }
    // testRequest("Circle")
    // testRequest("stone")
    // testRequest("Circle stone")
    // testRequest("!Circle stone")
    // testRequest("Circle !stone")
    // testRequest("!PlayerTrigger -megalith whatever")
    // testRequest("!whatever")
    // testRequest("-Circle")
    // testRequest("-whatever")
    // testRequest("-Circle stone")
    // testRequest("++PlayerTrigger ++MiniPuzzle")
    // testRequest("++PlayerTrigger ++MiniPuzzle generic")
    // testRequest("!MiniPuzzle dark")

    cur_world_pal=get_world_pal("pal01")
    set_sun_dir(vec4f(-0.1, 0.05, 1, 0))

    local t=TopoInverse(TopoBlot(3000, {ox=50, oz=50}))
    topo.append(t)
    // addGeo(GeoLake(t))

    WELEM("!Filler")({ targetTopo=t }).addToWGen(this, "fill")

    avgh=0
    rndh=5
    // doErosion=false
    base.generate()

    foreach (e in getGroup("fillWE")) e.placeObjects()

    BossMockupController()

    // local c =SpawnMonstersAround({ event="spawn1" })
    // local c2=SpawnMonstersAround({ event="spawn2" })

    // topo.append(TopoScatter([
    //   TopoCircle(30),
    //   c.topo,
    //   c2.topo,
    //   TopoCircle(30),
    //   TopoCircle(10),
    //   TopoCircle(10),
    //   TopoCircle(10),
    //   TopoCircle(10),
    //   ]))
    // addGeo(GeoSkeleton(topo[0], { avgh=10 }))
    // addGeo(c.geo)
    // addGeo(c2.geo)

    // base.generate()

    // c.placeObjects()
    // c2.placeObjects()

    // TriggerHub({ completionEvent="complete", events=["spawn1", "spawn2"] })
    // SpawnPortalListener("complete", { topo=c.topo })

    // function f(e)
    // {
    //   if ("sub" in e) f(e.sub)
    //   if ("children" in e)
    //     foreach (c in e.children) f(c)
    //   else
    //     TreeObject(e.ox, e.oz,
    //       get_pal_color(cur_world_pal, "leaves"),
    //       get_pal_color(cur_world_pal, "trunk"))
    // }
    // // f(topo)
  }
}
